<template>
  <div>
    <h1 class="text-2xl text-red-400">{{ title }}</h1>
    <ul>
      <li></li>
    </ul>

    <div class="flex flex-col">
      <div class="-my-2 overflow-x-auto sm:-mx-6 lg:-mx-8">
        <div class="py-2 align-middle inline-block min-w-full sm:px-6 lg:px-8">
          <div
            class="shadow overflow-hidden border-b border-gray-200 sm:rounded-lg"
          >
            <table class="min-w-full divide-y divide-gray-200">
              <thead class="bg-gray-50">
                <tr>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                  >
                    Id usuario
                  </th>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                  >
                    Nombre completo
                  </th>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                  >
                    Cargos
                  </th>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                  >
                    Sucursales
                  </th>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                  >
                    Horas / semana
                  </th>
                </tr>
                <tr v-for="user in users" v-bind:key="user.id">
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 tracking-wider"
                  >
                    {{ user.employeeId }}
                  </th>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 tracking-wider"
                  >
                    {{ user.firstName }} {{ user.lastName }}
                  </th>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 tracking-wider"
                  >
                    {{ getUserContract(user.contract) }}
                  </th>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 tracking-wider"
                  >
                    {{ getUserLocation(user.locationId[0]) }}
                  </th>
                  <th
                    scope="col"
                    class="px-6 py-3 text-left text-xs font-medium text-gray-500 tracking-wider"
                  >
                    {{ getHoursWeeklyByUser(user.contract) }}
                  </th>
                </tr>
              </thead>
            </table>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      title: 'Vista de Usuarios',
      users: [],
      contracts: [],
      locations: [],
      turns: [],
    };
  },
  beforeMount() {
    this.getUsers();
    this.getContracts();
    this.getLocations();
    this.getTurns();
  },
  methods: {
    async getUsers() {
      const res = await fetch('http://localhost:3004/users');
      const data = await res.json();
      this.users = [...data];
    },
    async getContracts() {
      const res = await fetch(' http://localhost:3004/contracts');
      const data = await res.json();
      this.contracts = [...data];
    },
    async getLocations() {
      const res = await fetch('http://localhost:3004/locations');
      const data = await res.json();
      this.locations = [...data];
    },
    async getTurns() {
      const res = await fetch(' http://localhost:3004/turns');
      const data = await res.json();
      this.turns = [...data];
    },
    getUserContract(userContract) {
      const contractFinded = this.contracts.find(
        (item) => item.id === userContract
      );
      return contractFinded.name;
    },
    getHoursWeeklyByUser(userContract) {
      const contractFinded = this.contracts.find(
        (item) => item.id === userContract
      );
      return contractFinded.legalMaxWeeklyHours;
    },
    getUserLocation(userLocation) {
      const locationFinded = this.locations.find(
        (item) => item.id === userLocation
      );
      return locationFinded.name;
    },
  },
};
</script>
